<?php
// Prevert Hacking
if (!defined('SMF'))
	die('Hacking attempt...');

function xLinks()
{
	global $txt, $context, $scripturl, $smcFunc;

	// You need to be an admin to edit settings!
	isAllowedTo('admin_forum');

	// All the admin bar, to make it right.
	if (!xlinks_is_smf2()) {
		adminIndex('edit_links');
	}
	loadTemplate('xLinks');
	loadLanguage('xLinks');

	// Delegation makes the world... that is, the package manager go 'round.
	$subActions = array(
		'main' 		=> 'mainLinks',
		'add' 		=> 'addLinks'
	);

	// By default do the basic settings.
	$_REQUEST['sa'] 	= isset($_REQUEST['sa']) && isset($subActions[$_REQUEST['sa']]) ? $_REQUEST['sa'] : 'main';
	$context['sub_action'] 	= $_REQUEST['sa'];

	$context['admin_tabs'] 	= array(
		'title' 	=> $txt['x-links_manage'],
		'description' 	=> $txt['x-links_desc'],
		'tabs' 		=> array(
				'main' => array(
					'title' => $txt['x-links_main'],
					'href' => $scripturl . '?action=xlinks',
				),
				'add' => array(
					'title' => $txt['x-links_add'],
					'href' => $scripturl . '?action=xlinks;sa=add',
				)
		)
	);

	// Attempt to automatically select the right tab.
	if (isset($context['admin_tabs']['tabs'][$context['sub_action']]))
		$context['admin_tabs']['tabs'][$context['sub_action']]['is_selected'] = true;
	// Otherwise it's going to be the browse anyway...
	else
		$context['admin_tabs']['tabs']['main']['is_selected'] = true;
	$context['page_title'] = $txt['x-links_manage'];
	// Call the right function.
	$subActions[$_REQUEST['sa']]();
}


function mainLinks()
{
	global $context, $txt, $smcFunc;

	$func_query			= 'xlinks_db_query';
	$func_num_rows 		= !empty($smcFunc['db_num_rows']) 	   ? $smcFunc['db_num_rows']      : 'mysql_num_rows';
	$func_fetch_assoc	= !empty($smcFunc['db_fetch_assoc'])   ? $smcFunc['db_fetch_assoc']   : 'mysql_fetch_assoc';
	$func_free_result	= !empty($smcFunc['db_free_result'])   ? $smcFunc['db_free_result']   : 'mysql_free_result';
	$func_escape		= !empty($smcFunc['db_escape_string']) ? $smcFunc['db_escape_string'] : 'mysql_escape_string';

	if(isset($_POST['save'])) {
		foreach($_POST['link'] as $id => $values) {
			if(isset($values['delete'])) {
				$func_query("
					DELETE FROM `{db_prefix}xlinks`
					WHERE `id` = '".$func_escape($id)."'");
			}
			else {
				$func_query("
					UPDATE `{db_prefix}xlinks`
					SET 	`sort` = '".$func_escape($values['sort'])."',
							`name` = '".$func_escape($values['name'])."',
							`href` = '".$func_escape(serialize(array('href'=>@$values['href'],'in_new'=>@$values['in_new'])))."',
							`title` = '".$func_escape($values['title'])."',
							`style` = '".$func_escape($values['style'])."'
					WHERE `id` = '".$func_escape($id)."'"
				);
			}
		}
		if (xlinks_is_smf2()) {
			redirectexit('action=admin;area=xlinks');
		}
		else {
			redirectexit('action=xlinks');
		}
	}

	$context['sub_template'] = 'main';
	$context['page_title'] 	 = $txt['x-links_title'];
}

function addLinks()
{
	global $db_prefix, $txt, $context, $smcFunc;

	$func_query			= 'xlinks_db_query';
	$func_num_rows 		= !empty($smcFunc['db_num_rows']) 	   ? $smcFunc['db_num_rows']      : 'mysql_num_rows';
	$func_fetch_assoc	= !empty($smcFunc['db_fetch_assoc'])   ? $smcFunc['db_fetch_assoc']   : 'mysql_fetch_assoc';
	$func_free_result	= !empty($smcFunc['db_free_result'])   ? $smcFunc['db_free_result']   : 'mysql_free_result';
	$func_escape		= !empty($smcFunc['db_escape_string']) ? $smcFunc['db_escape_string'] : 'mysql_escape_string';

	if(isset($_POST['add']))
	{
		$func_query("
			INSERT INTO `{db_prefix}xlinks`
			(`sort`, `name`, `href`, `title`, `style`)
			VALUES
			('".$func_escape((int)$_POST['sort'])."', '".$func_escape($_POST['name'])."', '".$func_escape(serialize(array('href'=>$_POST['href'],'in_new'=>$_POST['in_new'])))."', '".$func_escape($_POST['title'])."', '".$func_escape($_POST['style'])."')"
		);

		if (xlinks_is_smf2()) {
			redirectexit('action=admin;area=xlinks');
		}
		else {
			redirectexit('action=xlinks');
		}
	}

	$context['sub_template']	= 'addLinks';
	$context['page_title']		= $txt['x-links_add_title'];
}

function xlinks_is_smf2()
{
    global $forum_version;
    return substr($forum_version, 0, strlen('SMF x')) == 'SMF 2';
}

if (!function_exists('xlinks_db_query')) {
	function xlinks_db_query($query)
	{
		global $smcFunc, $db_prefix;
		$result = null;
		if (!empty($smcFunc['db_query'])) {
			$result = $smcFunc['db_query']('', $query);
		}
		else {
			$query = str_replace('{db_prefix}', $db_prefix, $query);
			$result = db_query($query, __FILE__, __LINE__);
		}
		return $result;
	}
}
?>