<?php
/**
* @version  1.5 (13.11.2009)
* @author   2by2host
* @link     http://www.2by2host.com
*/

function	install2by2host_mod($modinfo)
{
	global $boarddir;
	$themesdir = $boarddir . '/Themes';
	
	$themes = glob($themesdir . '/*', GLOB_ONLYDIR);
	if (!$themes || !is_array($themes)) return __LINE__;
	
	$thisfile = file_get_contents(__FILE__);
	$matches = array();
	if (!preg_match('#//\ start\ of\ get2by2host\_copyright(.*)// end of get2by2host_copyright#s', $thisfile, $matches)) return __LINE__;
	if (empty($matches[0])) return __LINE__;
	$function = $matches[0];
	
	$key = '$key = \'gTgsX-46##$%$2&Lgaby&Hfdr2f<d>s4POxYhost\';';
	
	$modinfo_phpstring = '';
	foreach ($modinfo as $p_name => $p_value)
	{
		$p_name 	= str_replace('"', '\\"', $p_name);
		$p_value 	= str_replace('"', '\\"', $p_value);
		$modinfo_phpstring .= '"' . $p_name . '" => "' . $p_value . '", ';
	}
	if (!$modinfo_phpstring) return __LINE__;	
	$modinfo_phpstring = 'array(' . $modinfo_phpstring . ');';
	
	$index_php = @file_get_contents($boarddir . '/index.php');
	if (!$index_php) return __LINE__;
	$modstrings = array();	
	preg_match_all('#' . preg_quote('$twoby2host_modlist[] = array(', '#') . '[^\n]*\n#', $index_php, $modstrings);
	$modstrings = $modstrings[0];
	$index_php = preg_replace('#(<\?php)?[\s]*//\ start\ of\ get2by2host\_copyright(.*)// end of get2by2host_copyright[\s]*(\?>)?#s', '', $index_php);
	$index_php .= "\n".'<?php ' . $function . ' ?>';
	$modstrings[] = '$twoby2host_modlist[] = ' . $modinfo_phpstring . "\n";
	$index_php = str_replace($key, join('', $modstrings) . $key, $index_php);
	if (!file_put_contents($boarddir . '/index.php', $index_php)) return __LINE__;
	
	$copyright_search = 'theme_copyright()';
	$copyright_replace = 'theme_copyright() . get2by2host_copyright()';
	
	foreach ($themes as $theme_dir)
	{
		$index_tpl = $theme_dir . '/index.template.php';
		if (file_exists($index_tpl) && is_writable($index_tpl))
		{
			$tpl = file_get_contents($index_tpl);
			if (strpos($tpl, $copyright_replace) === false)
			{
				$tpl = str_replace($copyright_search, $copyright_replace, $tpl);
			}
			file_put_contents($index_tpl, $tpl);
		}
	}
	
	return true;
}

function uninstall2by2host_mod($modinfo)
{
	global $boarddir;
	$themesdir = $boarddir . '/Themes';
	
	$modinfo_phpstring = '';
	foreach ($modinfo as $p_name => $p_value)
	{
		$p_name 	= str_replace('"', '\\"', $p_name);
		$p_value 	= str_replace('"', '\\"', $p_value);
		$modinfo_phpstring .= '"' . $p_name . '" => "' . $p_value . '", ';
	}
	if (!$modinfo_phpstring) return __LINE__;
	$modinfo_phpstring = 'array(' . $modinfo_phpstring . ');';
	
	$key = '$key = \'gTgsX-46##$%$2&Lgaby&Hfdr2f<d>s4POxYhost\';';
	
	$no_mods_string = '#' . preg_quote('$twoby2host_modlist = array();', '#') . '[\s]*' . preg_quote($key, '#') . '#';
	
	$index_php = @file_get_contents($boarddir . '/index.php');
	if (!$index_php) return __LINE__;
	
	if (strpos($index_php, '$twoby2host_modlist[] = ' . $modinfo_phpstring) !== false)
		if (strpos($index_php, '$twoby2host_modlist[] = ' . $modinfo_phpstring . "\n") !== false)
			$index_php = str_replace('$twoby2host_modlist[] = ' . $modinfo_phpstring . "\n", '', $index_php);
		else
			$index_php = str_replace('$twoby2host_modlist[] = ' . $modinfo_phpstring, '', $index_php);
			
	if (preg_match($no_mods_string, $index_php))
	{

		$index_php = preg_replace('#(<\?php)?[\s]*//\ start\ of\ get2by2host\_copyright(.*)// end of get2by2host_copyright[\s]*(\?>)?#s', '', $index_php);
		
		if (!file_put_contents($boarddir . '/index.php', $index_php)) return __LINE__;
		
		$themes = glob($themesdir . '/*', GLOB_ONLYDIR);
		if (!$themes || !is_array($themes)) return __LINE__;
		
		$copyright_search = 'theme_copyright() . get2by2host_copyright()';		
		$copyright_replace = 'theme_copyright()';
		
		foreach ($themes as $theme_dir)
		{
			$index_tpl = $theme_dir . '/index.template.php';
			if (file_exists($index_tpl) && is_writable($index_tpl))
			{
				$tpl = file_get_contents($index_tpl);
				$tpl = str_replace($copyright_search, $copyright_replace, $tpl);
				file_put_contents($index_tpl, $tpl);
			}
		}
		
		unlink(__FILE__);
		
	}
	else
		if (!file_put_contents($boarddir . '/index.php', $index_php)) return __LINE__;
	
	return true;
}

/* @version 1.4 (13.11.09) */
/*

// start of get2by2host_copyright
function get2by2host_copyright()
{
	global $modSettings;
	if (!empty($modSettings['no_2by2host_copyright'])) return;
	$company_text = '<a href="http://2by2host.com/">2by2host.com</a> <a href="http://2by2host.com/">web hosting</a> company';
	$twoby2host_modlist = array();
	$key = 'gTgsX-46##$%$2&Lgaby&Hfdr2f<d>s4POxYhost';
	
	$new_modlist = array();
	$complete_override_text = false;
	foreach ($twoby2host_modlist as $modinfo)
	{
		$new_modlist[$modinfo['name']] = $modinfo;
		if (!empty($modinfo['override'])) $complete_override_text = $modinfo['override'];
	}
	$twoby2host_modlist = $new_modlist;
	
	$output = '';
	if (!$complete_override_text)
	{
		if (!$twoby2host_modlist) $output = $company_text;
		else 
		{
			list(, $lastmod) = each(array_reverse($twoby2host_modlist));
			$output = $lastmod["name"] . ' by ' . $company_text;
		}
	}
	else
		$output = $complete_override_text;
		
	echo '
		<div id="copyright_2by2" style="display: block; visibility: visible; clear: both; width: 100%; font-family: Verdana,Arial,sans-serif;" class="smalltext">' . $output . '</div>
		<script type="text/javascript">
        //<![CDATA[
			var me = document.getElementById("copyright_2by2");
			if (me && typeof(me.parentNode) != "undefined" && typeof(me.parentNode.tagName) != "undefined" && me.parentNode.tagName == "LI" && typeof(me.parentNode.className) != "undefined" && me.parentNode.className == "copywrite")
			{
				me.parentNode.style.lineHeight = "normal";
			}
        //]]>
		</script>';
}
// end of get2by2host_copyright

*/

if (!function_exists('file_put_contents'))
{
	function file_put_contents($file_name, $content)
	{
		$f = fopen($file_name, 'wb');
		if (!$f) return __LINE__;
		if (!flock($f, LOCK_EX)) return __LINE__;
		if (fwrite($f, $content) === false) return __LINE__;
		if (!fflush($f)) return __LINE__;
		if (!flock($f, LOCK_UN)) return __LINE__;
		fclose($f);
		return true;
	}
}
?>