<?php
if (!defined('SMF'))
	die('Hacking attempt...');

if (!function_exists('xlinks_db_query')) {
	function xlinks_db_query($query)
	{
		global $smcFunc, $db_prefix;
		$result = null;
		if (!empty($smcFunc['db_query'])) {
			$result = $smcFunc['db_query']('', $query);
		}
		else {
			$query = str_replace('{db_prefix}', $db_prefix, $query);
			$result = db_query($query, __FILE__, __LINE__);
		}
		return $result;
	}
}

function loadxLinks()
{
	global $db_prefix, $context, $smcFunc;

	$func_query			= 'xlinks_db_query';
	$func_num_rows 		= !empty($smcFunc['db_num_rows']) 	 ? $smcFunc['db_num_rows']    : 'mysql_num_rows';
	$func_fetch_assoc	= !empty($smcFunc['db_fetch_assoc']) ? $smcFunc['db_fetch_assoc'] : 'mysql_fetch_assoc';
	$func_free_result	= !empty($smcFunc['db_free_result']) ? $smcFunc['db_free_result'] : 'mysql_free_result';

	$qres = $func_query("
		SELECT * FROM `{db_prefix}xlinks`
		ORDER BY `sort`"
	);

	if($func_num_rows($qres) > 0) {

		while($row = $func_fetch_assoc($qres)) {
			$link = unserialize($row['href']);
			$context['xlinks'][$row['id']] = array(
				'sort'	=> htmlentities($row['sort']),
				'name'	=> htmlentities($row['name']),
				'href'	=> $link['href'],
				'in_new'=> $link['in_new'],
				'title' => htmlentities($row['title']),
				'style' => htmlentities($row['style'])
			);
		}

		$context['xlinks'] = stripslashes__recursive($context['xlinks']);
	}

	$func_free_result($qres);
}
?>